Index: apps/app_chanspy.c
===================================================================
--- apps/app_chanspy.c	(revision 246419)
+++ apps/app_chanspy.c	(working copy)
@@ -457,6 +457,12 @@
 {
 	struct ast_datastore *datastore = NULL;
 
+	/* If the previous channel has not been freed from this datastore, that
+	 * must be done before setting up a new one. */
+	if (chanspy_ds->chan) {
+		chanspy_ds_free(chanspy_ds);
+	}
+
 	ast_mutex_lock(&chanspy_ds->lock);
 
 	if (!(datastore = ast_channel_datastore_alloc(&chanspy_ds_info, chanspy_ds->unique_id))) {
@@ -687,6 +693,7 @@
 
 	ast_channel_setoption(chan, AST_OPTION_TXGAIN, &zero_volume, sizeof(zero_volume), 0);
 
+	chanspy_ds_free(&chanspy_ds);
 	ast_mutex_lock(&chanspy_ds.lock);
 	ast_mutex_unlock(&chanspy_ds.lock);
 	ast_mutex_destroy(&chanspy_ds.lock);
